local mod = foundation.createMod();

mod:registerAssetId("maps/HEIGHT_MAP_VP.png", "HEIGHT_MAP")
mod:registerAssetId("maps/MATERIAL_MASK_VP.png", "MATERIAL_MASK")
mod:registerAssetId("maps/flat_density.png", "FLAT_DENSITY_MAP")
mod:registerAssetId("maps/more_density.png", "MORE_DENSITY_MAP")
mod:registerAssetId("maps/mountain_density.png", "MOUNTAIN_DENSITY_MAP")
mod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

mod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_VP_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -19,
	MaxHeight = 190,
	VillagePathList = {
		{
			Entrance = { 600, 0, 10 },
			Exit = { 1000, 0, 500 }
		},		
		{
			Entrance = { 10, 0, 600 },
			Exit = { 500, 0, 1000 }
		}
	},
	SpawnList = {
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 50 , 55 , 630 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 1.4, 1.4, 1.4 },
			PatchBeforeVersion = "1.0.0"
			},
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 160 , 58 , 650 }, 
			Orientation = { 0.0, 150.0 , 0.0},
			Scale = { 1.4, 1.4, 1.6 },
			PatchBeforeVersion = "1.0.0"
			},
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 320 , 52 , 880 },  
			Orientation = { 0.0, 35.0 , 0.0},
			Scale = { 1.4, 1.4, 1.6 },
			PatchBeforeVersion = "1.0.0"
			},
				
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 820 , 58 , 110 },   
			Orientation = { 0.0, 150.0 , 0.0},
			Scale = { 1.4, 1.4, 1.6 },
			PatchBeforeVersion = "1.0.0"
			},
		
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 970 , 52 , 200 },  
			Orientation = { 0.0, 80.0 , 0.0},
			Scale = { 1.4, 1.4, 1.4 },
			PatchBeforeVersion = "1.0.0"
		   }
		},	
	DensitySpawnList = {
		{
			DensityMap = "FLAT_DENSITY_MAP",
			Density = 0.8,  
			PrefabConfigList = {
			{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = .1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 3.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 2.0
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 2 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK", "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK" },   
					RandomWeight = 3.0,   
					OffsetSizeRange = {   
						Min = 0.75,
						Max = 1.6
					},
					OrientationRange = {     
						Min = { 0, -180, 0 },
						Max = { 0, 180, 0 }
					},
					ScaleRange = {    
						Min = 0.9,
						Max = 1.3
					},
					ColorRange = {     
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 0.7, 0.7, 0.7, 1 }
					}
				},	
				{
					PrefabList = { "PREFAB_TREE_OAK", "PREFAB_TREE_PINE" },
					RandomWeight = 2.0,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.4
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 1}
					}
				}
			}
		},
		{
			DensityMap = "MORE_DENSITY_MAP",
			Density = 0.7,
			PrefabConfigList = {
			{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = .1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 3.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 2.5
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 4 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_POPLAR", "PREFAB_TREE_OAK" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.8,
						Max = 1.2
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 2}
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK" },
					RandomWeight = 2,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.6
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.8,
						Max = 1.3
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 3}
					}
				}
			}
		},
		{
			DensityMap = "MOUNTAIN_DENSITY_MAP",
			Density = .9,
			PrefabConfigList = {
			{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = .1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 3.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 3.0
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 3 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 2.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 2.0
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 3 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE", "PREFAB_TREE_OAK" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.6
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1.6
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 3}
					}
				}
			}
		},
		{
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 100,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 100,
					OffsetSizeRange = {
						Min = 1.5,
						Max = 1.5
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.5,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 2 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 2,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 2,
						Max = 2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 2,
						Max = 2
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = "FISH_DENSITY_MAP",
			Density = 5,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})

